#
# Copyright (c) 2008-2018 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_content.features.header.interfaces import IHeaderTarget, IHeaderSettings
from pyams_default_theme.layer import IPyAMSDefaultLayer

# import packages
from pyams_utils.traversing import get_parent
from pyams_viewlet.viewlet import contentprovider_config, ViewContentProvider


@contentprovider_config(name='pyams.header', layer=IPyAMSDefaultLayer)
class HeaderContentProvider(ViewContentProvider):
    """Header content provider"""

    header = None

    def update(self):
        parent = get_parent(self.context, IHeaderTarget)
        if parent is not None:
            self.header = IHeaderSettings(parent, None)

    def render(self):
        if self.header is None:
            return ''
        renderer = self.header.get_renderer(self.request)
        if renderer is None:
            return ''
        return renderer.render()
